
void hexdump(const void *mem, uint32_t len, uint8_t cols = 16) {
  const uint8_t* src = (const uint8_t*) mem;
  Serial.printf("\n[HEXDUMP] Address: 0x%08X len: 0x%X (%d)", (ptrdiff_t)src, len, len);
  for(uint32_t i = 0; i < len; i++) {
    if(i % cols == 0) {
      Serial.printf("\n[0x%08X] 0x%08X: ", (ptrdiff_t)src, i);
    }
      Serial.printf("%02X ", *src);
    src++;
  }
      Serial.printf("\n");
}

// Arduino like analogWrite
  void ledcAnalogWrite(uint8_t channel, uint32_t value, uint32_t valueMax = 1023) {   // value has to be between 0 and valueMax
  uint32_t duty = (8191 / valueMax) * _min(value, valueMax);                          // calculate duty, 8191 from 2 ^ 13 - 1
  ledcWrite(channel, duty);                                                           // write duty to LEDC
}
