// routine for ESP32 analogwrite
#define LEDC_CHANNEL_0     0    // use first channel of 16 channels (started from zero)
#define LEDC_CHANNEL_1     1
#define LEDC_TIMER_13_BIT  13   // use 13 bit precission for LEDC timer
#define LEDC_BASE_FREQ     5000   // use 5000 Hz as a LEDC base frequency

void LED_start() {
  pinMode(LED_BUILTIN, OUTPUT);
  pinMode(LEDext, OUTPUT);
//  analogWriteRange(1023);                                         //ESP32 Update
  ledcSetup(LEDC_CHANNEL_0, LEDC_BASE_FREQ, LEDC_TIMER_13_BIT);     //ESP32 Update
  ledcSetup(LEDC_CHANNEL_1, LEDC_BASE_FREQ, LEDC_TIMER_13_BIT);     //ESP32 Update
  ledcAttachPin(LED_BUILTIN, LEDC_CHANNEL_0);                            //ESP32 Update
  ledcAttachPin(LEDext, LEDC_CHANNEL_1);                            //ESP32 Update

  writeLED(45);                // Am Anfang gleich Startwert an Dimmer schicken
}


static void writeLED(int LEDPWM) {
  dimmvalue = LEDPWM;

  if (dimmvalue < 58) { CalcValue = dimmvalue -1;  }
  else { CalcValue= 1.3*pow(1.069675, dimmvalue-1);  }

  CalcValue = (dimmvalue -1)*31/3;          // test für LCM-40 linear

  ledcAnalogWrite(LEDC_CHANNEL_0, CalcValue);     //ESP32 Update
  ledcAnalogWrite(LEDC_CHANNEL_1, CalcValue);     //ESP32 Update
}
